
CREATE SCHEMA Allgemeine_Geometrieobjekte

-- Historie:
--
-- 29.10.2000 - 1.000 (1.001)
-- Schema in den OKSTRA integriert


CREATE TABLE Eigensch_allgem_Geometrieobj (
   Eigensch_allgem_Geometrieobj_ID
      INTEGER NOT NULL PRIMARY KEY,
   Bezeichnung
      VARCHAR(255)
)

CREATE TABLE Eigensch_allgem_Geometrieobj__Fachbedeutung (
   Eigensch_allgem_Geometrieobj
      INTEGER NOT NULL REFERENCES Eigensch_allgem_Geometrieobj,
   Fachbedeutung
      VARCHAR(255) NOT NULL
)

CREATE TABLE Eigensch_allgem_Geometrieobj__Informationstext (
   Eigensch_allgem_Geometrieobj
      INTEGER NOT NULL REFERENCES Eigensch_allgem_Geometrieobj,
   Informationstext
      VARCHAR(255) NOT NULL
)

CREATE TABLE allgemeines_Punktobjekt (
   allgemeines_Punktobjekt_ID
      INTEGER NOT NULL PRIMARY KEY,
   FOREIGN KEY (allgemeines_Punktobjekt_ID) REFERENCES Geometrieschema.Punktobjekt_Modell,
   FOREIGN KEY (allgemeines_Punktobjekt_ID) REFERENCES Eigensch_allgem_Geometrieobj
)

CREATE TABLE Symbol (
   Symbol_ID
      INTEGER NOT NULL PRIMARY KEY,
   FOREIGN KEY (Symbol_ID) REFERENCES Geometrieschema.Punktobjekt_Modell,
   Symbolbedeutung
      VARCHAR(255) NOT NULL,
   Breite
      REAL NOT NULL, -- Groesse
   CHECK ( Breite>=0 ),
   Hoehe
      REAL NOT NULL, -- Groesse
   CHECK ( Hoehe>=0 ),
   Einheit
      INTEGER NOT NULL REFERENCES Einheit,
   Drehwinkel
      REAL NOT NULL, -- Winkel
   mit_Bezug_auf_allg_Punktobjekt
      INTEGER REFERENCES allgemeines_Punktobjekt
)

CREATE TABLE Einheit (
   Kennung
      INTEGER NOT NULL PRIMARY KEY,
   Einheit
      VARCHAR(4) NOT NULL
)

INSERT INTO Kennung VALUES (0,'Welt')
INSERT INTO Kennung VALUES (1,'mm')

CREATE TABLE allgemeines_Linienobjekt (
   allgemeines_Linienobjekt_ID
      INTEGER NOT NULL PRIMARY KEY,
   FOREIGN KEY (allgemeines_Linienobjekt_ID) REFERENCES Geometrieschema.Linienobjekt_Modell,
   FOREIGN KEY (allgemeines_Linienobjekt_ID) REFERENCES Eigensch_allgem_Geometrieobj
)

CREATE TABLE Boeschungsschraffen (
   Boeschungsschraffen_ID
      INTEGER NOT NULL PRIMARY KEY,
   Boeschungsbedeutung
      VARCHAR(255) NOT NULL
)

CREATE TABLE Boeschungsschraffen__hat_Linie (
   Boeschungsschraffen
      INTEGER NOT NULL REFERENCES Boeschungsschraffen,
   allgemeines_Linienobjekt
      INTEGER NOT NULL REFERENCES allgemeines_Linienobjekt
)

CREATE TABLE allgemeines_Flaechenobjekt (
   allgemeines_Flaechenobjekt_ID
      INTEGER NOT NULL PRIMARY KEY,
   FOREIGN KEY (allgemeines_Flaechenobjekt_ID) REFERENCES Geometrieschema.Flaechenobjekt_Modell,
   FOREIGN KEY (allgemeines_Flaechenobjekt_ID) REFERENCES Eigensch_allgem_Geometrieobj
)

CREATE TABLE ALKIS_Objekt_Punkt (
   ALKIS_Objekt_Punkt_ID
      INTEGER NOT NULL PRIMARY KEY,
   FOREIGN KEY (ALKIS_Objekt_Punkt_ID) REFERENCES Geometrieschema.Punktobjekt_Modell,
   FOREIGN KEY (ALKIS_Objekt_Punkt_ID) REFERENCES Eigensch_allgem_Geometrieobj,
   Identifikator
      VARCHAR(255) NOT NULL
)

CREATE TABLE ALKIS_Objekt_Linie (
   ALKIS_Objekt_Linie_ID
      INTEGER NOT NULL PRIMARY KEY,
   FOREIGN KEY (ALKIS_Objekt_Linie_ID) REFERENCES Geometrieschema.Linienobjekt_Modell,
   FOREIGN KEY (ALKIS_Objekt_Linie_ID) REFERENCES Eigensch_allgem_Geometrieobj,
   Identifikator
      VARCHAR(255) NOT NULL
)

CREATE TABLE ALKIS_Objekt_Flaeche (
   ALKIS_Objekt_Flaeche_ID
      INTEGER NOT NULL PRIMARY KEY,
   FOREIGN KEY (ALKIS_Objekt_Flaeche_ID) REFERENCES Geometrieschema.Flaechenobjekt_Modell,
   FOREIGN KEY (ALKIS_Objekt_Flaeche_ID) REFERENCES Eigensch_allgem_Geometrieobj,
   Identifikator
      VARCHAR(255) NOT NULL
)

CREATE TABLE Dreieck (
   Dreieck_ID
      INTEGER NOT NULL PRIMARY KEY,
   Dreiecksbedeutung
      VARCHAR(255) NOT NULL,
   in_DGM
      INTEGER NOT NULL REFERENCES Entwurf.DGM
)

CREATE TABLE Dreieck__hat_Punkte (
   Dreieck
      INTEGER NOT NULL REFERENCES Dreieck,
   allgemeines_Punktobjekt
      INTEGER NOT NULL REFERENCES allgemeines_Punktobjekt,
   folgt_auf_allgemeines_Punktobjekt
      INTEGER REFERENCES allgemeines_Punktobjekt
)

CREATE TABLE Dreieck__hat_Seiteneigenschaften (
   Dreieck
      INTEGER NOT NULL REFERENCES Dreieck,
   Seiteneigenschaft
      INTEGER NOT NULL REFERENCES Seiteneigenschaft,
   folgt_auf_Seiteneigenschaft
      INTEGER REFERENCES Seiteneigenschaft
)

CREATE TABLE Seiteneigenschaft (
   Kennung
      INTEGER NOT NULL PRIMARY KEY,
   Seiteneigenschaft
      VARCHAR(13) NOT NULL
)

INSERT INTO Seiteneigenschaft VALUES (1,'normale Seite')
INSERT INTO Seiteneigenschaft VALUES (2,'Bruchlinie')
INSERT INTO Seiteneigenschaft VALUES (3,'Formlinie')

CREATE TABLE Beschriftung (
   Beschriftung_ID
      INTEGER NOT NULL PRIMARY KEY,
   FOREIGN KEY (Beschriftung_ID) REFERENCES Geometrieschema.Punktobjekt_Modell,
   Text
      VARCHAR(255) NOT NULL, -- RTF
   Textbedeutung
      VARCHAR(255) NOT NULL,
   Breite
      REAL NOT NULL, -- Groesse
   CHECK ( Breite>=0 ),
   Hoehe
      REAL NOT NULL, -- Groesse
   CHECK ( Hoehe>=0 ),
   Einheit
      INTEGER REFERENCES Einheit,
   Drehwinkel
      REAL, -- Winkel
   Textneigung
      REAL, -- Winkel
   Schriftart
      VARCHAR(255),
   Kasten
      INTEGER REFERENCES Logical_Types.Boolean,
   Fahne
      INTEGER REFERENCES Fahne,
   vertikale_Ausrichtung
      INTEGER REFERENCES vertikale_Ausrichtung,
   horizontale_Ausrichtung
      INTEGER REFERENCES horizontale_Ausrichtung,
   zu_Punktobjekt_Modell
      INTEGER REFERENCES Geometrieschema.Punktobjekt_Modell
)

CREATE TABLE Fahne (
   Kennung
      INTEGER NOT NULL PRIMARY KEY,
   Fahne
      VARCHAR(8) NOT NULL
)

INSERT INTO Fahne VALUES (0,'ohne')
INSERT INTO Fahne VALUES (1,'gerade')
INSERT INTO Fahne VALUES (2,'geknickt')

CREATE TABLE vertikale_Ausrichtung (
   Kennung
      INTEGER NOT NULL PRIMARY KEY,
   vertikale_Ausrichtung
      VARCHAR(9) NOT NULL
)

INSERT INTO vertikale_Ausrichtung VALUES (0,'zentriert')
INSERT INTO vertikale_Ausrichtung VALUES (1,'oberhalb')
INSERT INTO vertikale_Ausrichtung VALUES (2,'unterhalb')

CREATE TABLE horizontale_Ausrichtung (
   Kennung
      INTEGER NOT NULL PRIMARY KEY,
   horizontale_Ausrichtung
      VARCHAR(9) NOT NULL
)

INSERT INTO horizontale_Ausrichtung VALUES (0,'zentriert')
INSERT INTO horizontale_Ausrichtung VALUES (1,'links')
INSERT INTO horizontale_Ausrichtung VALUES (2,'rechts')



CREATE SCHEMA Entwurf


CREATE TABLE DGM (
   DGM_ID
      INTEGER NOT NULL PRIMARY KEY,
   hat_allgemeine_Eigenschaften
      INTEGER NOT NULL REFERENCES allgemeine_Eigenschaften
)

CREATE TABLE allgemeine_Eigenschaften (
   allgemeine_Eigenschaften_ID
      INTEGER NOT NULL PRIMARY KEY,
   Bezeichnung
      VARCHAR(255) NOT NULL,
   fachliche_Bedeutung
      VARCHAR(255) NOT NULL,
   Informationstext
      VARCHAR(255)
)



CREATE SCHEMA Geometrieschema


CREATE TABLE Punktobjekt_Modell (
   Punktobjekt_Modell_ID
      INTEGER NOT NULL PRIMARY KEY
)

CREATE TABLE Punktobjekt_Modell__dargestellt_von_Punkt (
   Punktobjekt_Modell
      INTEGER NOT NULL REFERENCES Punktobjekt_Modell,
   Punkt
      INTEGER NOT NULL REFERENCES Punkt
)

CREATE TABLE Linienobjekt_Modell (
   Linienobjekt_Modell_ID
      INTEGER NOT NULL PRIMARY KEY
)

CREATE TABLE Linienobjekt_Modell__dargestellt_von_Linie (
   Linienobjekt_Modell
      INTEGER NOT NULL REFERENCES Linienobjekt_Modell,
   Linie
      INTEGER NOT NULL REFERENCES Linie
)

CREATE TABLE Flaechenobjekt_Modell (
   Flaechenobjekt_Modell_ID
      INTEGER NOT NULL PRIMARY KEY
)

CREATE TABLE Flaechenobjekt_Modell__dargestellt_von_Flaeche (
   Flaechenobjekt_Modell
      INTEGER NOT NULL REFERENCES Flaechenobjekt_Modell,
   Flaeche
      INTEGER NOT NULL REFERENCES Flaeche
)

CREATE TABLE Raumbezugsart (
   Raumbezugsart_ID
      INTEGER NOT NULL PRIMARY KEY
)

CREATE TABLE Punkt (
   Punkt_ID
      INTEGER NOT NULL PRIMARY KEY,
   FOREIGN KEY (Punkt_ID) REFERENCES Raumbezugsart,
   hat_Lage
      INTEGER NOT NULL REFERENCES direct_positioning_schema.direct_position
)

CREATE TABLE gerechneter_Punkt (
   gerechneter_Punkt_ID
      INTEGER NOT NULL PRIMARY KEY,
   FOREIGN KEY (gerechneter_Punkt_ID) REFERENCES Punkt
)

CREATE TABLE Linie (
   Linie_ID
      INTEGER NOT NULL PRIMARY KEY,
   FOREIGN KEY (Linie_ID) REFERENCES Raumbezugsart
)

-- Bem: Redundanz beseitigen

CREATE TABLE Linie__besteht_aus_Linienelementen (
   Linie
      INTEGER NOT NULL REFERENCES Linie,
   Linienelement_3D
      INTEGER NOT NULL REFERENCES Linienelement_3D,
   folgt_auf_Linienelement_3D
      INTEGER REFERENCES Linienelement_3D
)

CREATE TABLE Linienelement_3D (
   Linienelement_3D_ID
      INTEGER NOT NULL PRIMARY KEY,
   beginnt_bei_Punkt
      INTEGER NOT NULL REFERENCES Punkt,
   endet_bei_Punkt
      INTEGER NOT NULL REFERENCES Punkt,
   zu_Linie
      INTEGER NOT NULL REFERENCES Linie
)

CREATE TABLE Linienelement_Spline (
   Linienelement_Spline_ID
      INTEGER NOT NULL PRIMARY KEY,
   FOREIGN KEY (Linienelement_Spline_ID) REFERENCES Linienelement_3D,
   Kruemmung_am_Anfang
      REAL,
   Kruemmung_am_Ende
      REAL,
   Tangente_am_Anfang
      REAL, -- Winkel
   Tangente_am_Ende
      REAL -- Winkel
)

-- Bem: Reihenfolge anpassen

CREATE TABLE Linienelement_Spline__hat_Stuetzpunkte (
   Linienelement_Spline
      INTEGER NOT NULL REFERENCES Linienelement_Spline,
   Punkt
      INTEGER NOT NULL REFERENCES Punkt,
   folgt_auf_Punkt
      INTEGER REFERENCES Punkt
)

CREATE TABLE gerades_Linienelement (
   gerades_Linienelement_ID
      INTEGER NOT NULL PRIMARY KEY,
   FOREIGN KEY (gerades_Linienelement_ID) REFERENCES Linienelement_3D
)

CREATE TABLE Kreisbogen (
   Kreisbogen_ID
      INTEGER NOT NULL PRIMARY KEY,
   FOREIGN KEY (Kreisbogen_ID) REFERENCES Linienelement_3D,
   hat_Zwischenpunkt
      INTEGER NOT NULL REFERENCES Punkt
)

CREATE TABLE Linie_Flaechenelement (
   Linie_Flaechenelement_ID
      INTEGER NOT NULL PRIMARY KEY,
   bei_Linienfunktion
      VARCHAR(255) NOT NULL,
   Linie
      INTEGER NOT NULL REFERENCES Linie
)

CREATE TABLE Flaeche (
   Flaeche_ID
      INTEGER NOT NULL PRIMARY KEY,
   FOREIGN KEY (Flaeche_ID) REFERENCES Raumbezugsart
)

CREATE TABLE Flaechenelement (
   Flaechenelement_ID
      INTEGER NOT NULL PRIMARY KEY,
   FOREIGN KEY (Flaechenelement_ID) REFERENCES Flaeche,
   beschrieben_durch_Linien
      INTEGER NOT NULL REFERENCES Linie_Flaechenelement
)

CREATE TABLE komplexe_Flaeche (
   komplexe_Flaeche_ID
      INTEGER NOT NULL PRIMARY KEY,
   FOREIGN KEY (komplexe_Flaeche_ID) REFERENCES Flaeche,
   hat_erste_Flaeche
      INTEGER NOT NULL REFERENCES Flaeche,
   hat_zweite_Flaeche
      INTEGER NOT NULL REFERENCES Flaeche
)



CREATE SCHEMA direct_positioning_schema


CREATE TABLE direct_position (
   direct_position_ID
      INTEGER NOT NULL PRIMARY KEY,
   in_pos_ref_system
      VARCHAR(30),
   in_coordinate_system
      VARCHAR(30)
)

CREATE TABLE direct_position__Koordinate (
   direct_position
      INTEGER NOT NULL REFERENCES direct_position,
   Koordinate
      REAL NOT NULL,
   folgt_auf_Koordinate
      REAL
)
